
#include <XmippData/xmippImages.hh>
#include <XmippData/xmippSelFiles.hh>
#include <XmippData/xmippMatrices3D.hh>
#include <XmippData/xmippMatrices2D.hh>
#include <XmippData/xmippMatrices1D.hh>
#include <XmippData/xmippGeometry.hh>
#include <XmippData/xmippVolumes.hh>
#include <XmippData/xmippProjection.hh>
#include <iostream>
#include <cassert>
#include <cstring>
#include <cmath>
#include <algorithm>
#include "comun.h"
using namespace std;


int main( int argc, char** argv){
  FileName fnVol1;
  VolumeXmipp vol;


  fnVol1 = argv[1];
  int Zdim, Ydim, Xdim,
      Zdim2, Ydim2, Xdim2;
  try {
    vol.read(fnVol1);

    Zdim = vol.img.SliNo(); Ydim = vol.img.RowNo(); Xdim = vol.img.ColNo();
  }catch (Xmipp_error XE) {cout << XE; exit(1);}

  int z, y, x, tamano = Zdim * Ydim * Xdim;
  double a, b;
  scanf("%lf %lf", &a, &b);
  for (z = 0; z < Zdim; ++z) for (y = 0; y < Ydim; ++y) for (x = 0; x < Xdim; ++x) {
    printf("%lf\n", vol(z, y, x));
    vol(z, y, x) = vol(z, y, x) * a + b;
  }
  vol.write(fnVol1);
}
