/* vim: set filetype=cpp : */

/*............................................................................*/
__device__ float bessi0(float x)   // aproximacion a 2 - j0(x) (del cmath)
{
float y, ax, ans;
if ((ax=fabsf(x)) < 3.75) {
   y=x/3.75;
   y*=y;
   ans=1.0+y*(3.5156229+y*(3.0899424+y*(1.2067492
      +y*(0.2659732+y*(0.360768e-1+y*0.45813e-2)))));
} else {
   y=3.75/ax;
   ans=(expf(ax)/sqrtf(ax))*(0.39894228+y*(0.1328592e-1
      +y*(0.225319e-2+y*(-0.157565e-2+y*(0.916281e-2
      +y*(-0.2057706e-1+y*(0.2635537e-1+y*(-0.1647633e-1
      +y*0.392377e-2))))))));
}
return ans;
}

/*............................................................................*/
__device__ float bessi1(float x)   // aproximacion a j1(x) (del cmath)
{
float ax, ans;
float y;
if ((ax=fabsf(x)) < 3.75) {
   y=x/3.75;
   y*=y;
   ans=ax*(0.5+y*(0.87890594+y*(0.51498869+y*(0.15084934
      +y*(0.2658733e-1+y*(0.301532e-2+y*0.32411e-3))))));
} else {
   y=3.75/ax;
   ans=0.2282967e-1+y*(-0.2895312e-1+y*(0.1787654e-1
      -y*0.420059e-2));
   ans=0.39894228+y*(-0.3988024e-1+y*(-0.362018e-2
   +y*(0.163801e-2+y*(-0.1031555e-1+y*ans))));
   ans *= (exp(ax)/sqrt(ax));
}
return x < 0.0 ? -ans : ans;
}
__device__ float bessi2  (float x) {return (x==0)? 0:bessi0  (x)-(2*1  )/x*bessi1  (x);}

/* Value of a blob --------------------------------------------------------- */
/*
float kaiser_value(float r, float a, float alpha, int m) {
float rda, rdas, arg, w;

rda = r/a;
rdas = rda*rda;
if(rdas <= 1.0){
       arg = alpha * sqrt(1.0-rdas);
       if (m==0) {
          w = bessi0(arg) / bessi0(alpha);
       } else if (m==1) {
          if (alpha==0.0)
             w = 1.0-rdas;
          else
             w = sqrt(1.0-rdas) * bessi1(arg) / bessi1(alpha);
       } else if (m==2) {
          if (alpha==0.0)
             w = (1.0-rdas)*(1.0-rdas);
          else
             w = (1.0-rdas) * bessi2(arg) / bessi2(alpha);
       } else puts("m out of range in kaiser_value()");

} else
    w = 0.0;

return w;
}
*/

/* Line integral through a blob -------------------------------------------- */
/* Value of line integral through Kaiser-Bessel radial function
   (n >=2 dimensions) at distance s from center of function.
   Parameter m = 0, 1, or 2. */

/* Suponemos: a es el radio del blob 
 * distancia, radio, alpha, orden */
__device__ float kaiser_proj(float s, float a, float alpha, int m) {
float sda, sdas, w, arg, p;

sda = s/a;
sdas = sda*sda;
w = 1.0 - sdas;
if (w > eps) {
    arg = alpha * sqrtf(w);
    if (m==0) {
        if (alpha==0.0)
            p = 2.0 * a * sqrt(w);
        else
            p = (2.0*a/alpha) * sinhf(arg) / bessi0(alpha);

    } else if (m==1) {
        if (alpha==0.0)
            p = 2.0 * a * w * sqrtf(w) * (2.0/3.0);
        else
            p = (2.0*a/alpha) * sqrtf(w) * (coshf(arg) - sinhf(arg)/arg)
                / bessi1(alpha);

    } else if (m==2) {
        if (alpha==0.0)
            p = 2.0*a * w*w*sqrtf(w) * (8.0/15.0);
        else
            p = (2.0*a/alpha) * w *
        ( (3.0/(arg*arg)+1.0)*sinhf(arg) - (3.0/arg)*coshf(arg) ) / bessi2(alpha);
    }/* else puts("m out of range in kaiser_proj()");*/

} else
    p = 0.0;

return p;
}
